=== debian/control ===
Source: gccxml
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9), cmake, autotools-dev
Build-Conflicts: ccache
Homepage: http://www.gccxml.org/
Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/gccxml/trunk/
Vcs-Svn: svn://svn.debian.org/collab-maint/deb-maint/gccxml/trunk
Standards-Version: 3.9.3

Package: gccxml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, g++
Description: XML output extension to GCC
 There is one open-source C++ parser, the C++ front-end to GCC, which
 is currently able to deal with the language in its entirety. The
 purpose of the GCC-XML extension is to generate an XML description of
 a C++ program from GCC's internal representation. Since XML is easy to
 parse, other development tools will be able to work with C++ programs
 without the burden of a complicated C++ parser.

Package: libgccxml-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Libraries for building extension to gccxml output
 There is one open-source C++ parser, the C++ front-end to GCC, which
 is currently able to deal with the language in its entirety. The
 purpose of the GCC-XML extension is to generate an XML description of
 a C++ program from GCC's internal representation. Since XML is easy to
 parse, other development tools will be able to work with C++ programs
 without the burden of a complicated C++ parser.
 .
 These libraries are part of the GCC-XML tool.
