=== debian/changelog ===
gccxml (0.9.0+git20140716-6) unstable; urgency=medium

  * castxml-wrapper.py: Correct call to os.execv() (thanks, Michael
    Terry).  Closes: #795299.

 -- Steve M. Robbins <smr@debian.org>  Wed, 12 Aug 2015 20:03:40 -0500

gccxml (0.9.0+git20140716-5) unstable; urgency=medium

  * Replace with CastXML wrapper, which is GCC-5 compatible (Closes:
    #792280).

 -- Steve M. Robbins <smr@debian.org>  Fri, 07 Aug 2015 23:47:29 -0500

gccxml (0.9.0+git20140716-4) unstable; urgency=medium

  * Build-depend on GCC 4.9.  Closes: #777865.  This package will be
    shortly superceded by CastXML and therefore not worth the effort to
    port to GCC 5.

 -- Steve M. Robbins <smr@debian.org>  Sat, 27 Jun 2015 22:58:41 -0500

gccxml (0.9.0+git20140716-3) unstable; urgency=medium

  * patches/arm64-config-gcc-kludge.patch: New.  Enable building on arm64.
    Closes: #750449.

 -- Steve M. Robbins <smr@debian.org>  Wed, 24 Jun 2015 17:56:00 -0500

gccxml (0.9.0+git20140716-2) unstable; urgency=medium

  [ Mauricio Faria de Oliveira ]
  * patches/ppc64el-config-gcc.patch: New.  Add
    'powerpc64le-unknown-linux-gnu' to 'GCC/gcc/config.gcc'.  Closes: #762476.

  [ Steve M. Robbins ]
  * Prepare upload.

 -- Steve M. Robbins <smr@debian.org>  Tue, 30 Sep 2014 18:47:10 -0500

gccxml (0.9.0+git20140716-1) unstable; urgency=medium

  * Team upload.
  [ Dmitry Shachnev ]
  * Use dh_autotools-dev addon to update config.sub|guess.
    (Closes: #753472)

  [ Gianfranco Costamagna ]
  * New upstream snapshot (Closes: #746863).
  * Add get-orig-source target, to comply with policy.
  * Bump std-version to 3.9.5, no changes required.
  * Switch to tar.xz source tarballs.
  * drop patches/stl_algo.patch, merged upstream.
  * removing some prebuilt windows binaries.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 16 Jul 2014 10:06:17 +0200

gccxml (0.9.0+git20140610-2) unstable; urgency=medium

  * patches/stl_algo.patch: New.  Improve GCC 4.9 support.

 -- Steve M. Robbins <smr@debian.org>  Tue, 01 Jul 2014 13:38:52 -0500

gccxml (0.9.0+git20140610-1) unstable; urgency=medium

  * New upstream.
    - includes gcc 4.9 support.  Closes: #746823, #746846, #746853.

  * patches/debian-tests: refresh.

 -- Steve M. Robbins <smr@debian.org>  Tue, 10 Jun 2014 19:20:54 -0500

gccxml (0.9.0+git20140205-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream. Closes: #736172

 -- Mathieu Malaterre <malat@debian.org>  Wed, 05 Feb 2014 17:28:51 +0100

gccxml (0.9.0+git20130511-1) unstable; urgency=low

  * New upstream.
    - patches/128bits.patch: Remove.  Applied upstream.
    - fixed GCC 4.8 issues.  Closes: #701282, #701284.
    - fixed issue with __builtin_bswap{32,64}.  Closes: #699659.
  
  * control: update to debhelper 9.
  * makeSource.sh: update to upstream git repository.

 -- Steve M. Robbins <smr@debian.org>  Sat, 11 May 2013 15:37:51 -0500

gccxml (0.9.0+cvs20120420-5) UNRELEASED; urgency=low

  * Remove self from Uploaders

 -- Mathieu Malaterre <malat@debian.org>  Thu, 11 Apr 2013 12:06:15 +0200

gccxml (0.9.0+cvs20120420-4) unstable; urgency=high

  * Fix parsing of <limits> under GCC 4.7.1. Closes: #675181
    + debian/patches/128bits.patch

 -- Mathieu Malaterre <malat@debian.org>  Thu, 26 Jul 2012 16:53:41 +0200

gccxml (0.9.0+cvs20120420-3) unstable; urgency=low

  [ Mathieu Malaterre ]
  * Bump Std-Vers to 3.9.3, no changes needed
  * Use my @d.o alias, remove DMUA flag, not needed

  [ Steve M. Robbins ]
  * Rebuild without ccache.  Closes: #671173.
  * control: Build-conflict with ccache to avoid #671173 in future.

 -- Steve M. Robbins <smr@debian.org>  Fri, 04 May 2012 17:46:24 -0500

gccxml (0.9.0+cvs20120420-2) unstable; urgency=low

  * Testing/CMakeLists.txt: Disable float128.c test mistakenly added.

 -- Steve M. Robbins <smr@debian.org>  Sat, 21 Apr 2012 15:53:51 -0500

gccxml (0.9.0+cvs20120420-1) unstable; urgency=low

  * New upstream.
    - Add support for gcc 4.7.  Closes: #667174, #667521.

 -- Steve M. Robbins <smr@debian.org>  Fri, 20 Apr 2012 21:51:50 -0500

gccxml (0.9.0+cvs20111013-1) unstable; urgency=low

  [ Steve M. Robbins ]
  * New cvs snapshot.
    - Remove patches/02_quote-target-cpu-default.diff: applied upstream.
    - Remove patches/hurd-build.patch: applied upstream.
  
  [ Mathieu Malaterre ]
  * export CVSROOT from makeSource.sh directly
  * Compress using max compression
  * Add myself to Uploader. Set DM-Uploader: Yes
  * Redo the d/rules file to install dev files for mummy
  * Add libgccxml-dev package. Closes: #644594

 -- Steve M. Robbins <smr@debian.org>  Thu, 13 Oct 2011 22:54:14 -0500

gccxml (0.9.0+cvs20110723-3) unstable; urgency=low

  * patches/hurd-build.patch: New.  Fix build on hurd-i386 (thanks, Samuel
    Thibault).  Closes: #638577.

 -- Steve M. Robbins <smr@debian.org>  Sat, 03 Sep 2011 14:52:11 -0500

gccxml (0.9.0+cvs20110723-2) unstable; urgency=low

  * Upload to unstable.

 -- Steve M. Robbins <smr@debian.org>  Sat, 23 Jul 2011 23:47:47 -0500

gccxml (0.9.0+cvs20110723-1) experimental; urgency=low

  * New cvs snapshot.

  * Support/4.6/s390-linux-gnu:
  * Support/4.6/powerpc-linux-gnu: Remove.  The attempt to override
    c++config.h for these architectures did not work.  The gccxml wrapper
    puts /usr/share/gccxml-0.9/GCC/${GCC_VERSION} on the include path so
    can find in overrides for <header>, but not the architecture-specific
    headers in ${GCC_VERSION}/${ARCHITECTURE}.
  
  * Support/GCC/4.6/bits/c++config.h: New.  Use the amd64 version of this file
    which does not define symbols _GLIBCXX_INLINE_VERSION nor
    _GLIBCXX_LONG_DOUBLE_COMPAT and therefore avoids use of "inline
    namespace".
  
  * gccxml.install: Remove.
  * rules: Copy debian/Support to GCC_XML/Support prior to running tests.

 -- Steve M. Robbins <smr@debian.org>  Sat, 23 Jul 2011 13:53:27 -0500

gccxml (0.9.0+cvs20110626-2) experimental; urgency=low

  * Support: install override c++config.h for powerpc, s390.


