=== GCC_XML/VcInstall/CMakeLists.txt ===
--- 
+++ 
@@ -38,9 +38,6 @@
   ${GCCXML_SOURCE_DIR}/VcInstall/vc8sp1ExpressInclude.patch
   ${GCCXML_SOURCE_DIR}/VcInstall/vc9Include.patch
   ${GCCXML_SOURCE_DIR}/VcInstall/vc9PlatformSDK.patch
-  ${GCCXML_SOURCE_DIR}/VcInstall/vc9sp1Include.patch
-  ${GCCXML_SOURCE_DIR}/VcInstall/vc10Include.patch
-  ${GCCXML_SOURCE_DIR}/VcInstall/vc10PlatformSDK.patch
   )
 ADD_CUSTOM_TARGET(vcInstallPatch DEPENDS
   ${GCCXML_BINARY_DIR}/vcInstall_stamp.c)
