## gccxml 0.9.0+cvs20090916

=== GCC/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
 PROJECT(GCC C)
+IF(COMMAND CMAKE_POLICY)
+  CMAKE_POLICY(SET CMP0003 NEW)
+ENDIF(COMMAND CMAKE_POLICY)
 
 IF(GCCXML_INSTALL_COMPONENT_NAME_RUNTIME_EXECUTABLE)
   SET(GCCXML_INSTALL_COMPONENT_RUNTIME_EXECUTABLE
